package it.unitn.disi.ronchet.webChat.businessObjects;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import javax.servlet.ServletContext;

/**
 * Una stanza (Room) ha un nome (titolo) e una lista di messaggi.
 * @author ronchet
 */
public class Room {
    // Instance vars
    String title;
    MessageList messageList;
    // crea una nuova stanza e aggiungila alla lista delle stanza
    public Room(String title,ServletContext ctx){
        this.title=title;
        messageList=new MessageList();
        //aggiungi la stanza alla mappa delle stanze
        RoomMap roomMap=(RoomMap)ctx.getAttribute("roomMap");
        roomMap.put(title, this);        
    }
    public String getTitle(){return title;}
    // ottieni il titolo trasformato con encoding UTF-8 
    // (Il titolo senza encoding potrebbe contenere spazi che sarebbero problematici)
    public String getEncodedTitle() {
        String encodedTitle=null;
        try {
            encodedTitle=URLEncoder.encode(title,"UTF-8");
        } catch (UnsupportedEncodingException ex) {
            ex.printStackTrace();
        }
        System.out.println(title+"<->"+encodedTitle);
        return encodedTitle;
    }

    // ottieni la lista dei messaggi sotto forma di stringa formattata in HTML
        public String getFormattedMessageList(){
        return messageList.getFormattedMessageList();
    }        
    // aggiungi un nuovo messaggio alla lista
    public void addMessage(String user, String msgtxt) {
        Message msg=new Message(user,msgtxt);
        messageList.add(msg);
    }
/*
    int getLastMsgId(){
       return messageList.last().seqNumber;
    }
    // ottieni la lista dei messaggi
        public MessageList getMessageList(){
        return messageList;
    }
*/
}
