package it.unitn.disi.ronchet.webChat.businessObjects;
import java.util.Collection;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;

/**
 * RoomMap è una mappa che associa i titoli (encoded) con le stanza
 * Ha un metodo che restituisce la lista delle stanze formattata in HTML
 * @author ronchet
 */
public class RoomMap extends HashMap<String,Room> {
    // constants
    private final String PRE="<li><a href=F_ShowStanzaServlet?stanzaName=";
    private final String MID=">";
    private final String POST="</a></li>";
    public static final List<String> LINK_LIST =new LinkedList<>();
    //
    public String getFormattedRoomList(){
        String s="<h2>Non ci sono ancora stanze</h2>";
        if (!this.isEmpty()){
            Collection<Room> roomList=this.values();
            s="<h2>Entra in una delle stanze disponibili:</h2><ul>";
            for (Room r:roomList) {
                s=s+PRE+r.getEncodedTitle()+MID+r.title+POST;
            }
            s=s+"</ul>";
        }
        return s;
    }
}
