package it.unitn.disi.ronchet.webChat.servlets;

import it.unitn.disi.ronchet.webChat.businessObjects.Room;
import it.unitn.disi.ronchet.webChat.businessObjects.RoomMap;
import java.io.IOException;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author ronchet
 */
public class CreateStanzaServlet extends HttpServlet {

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        ServletContext ctx=request.getServletContext();
        // recupera la RoomMap, e se non c'e' creala.
        RoomMap roomMap=(RoomMap)ctx.getAttribute("roomMap");
        if (roomMap==null) {
            roomMap=new RoomMap();
            ctx.setAttribute("roomMap", roomMap);
        }
        String title=request.getParameter("roomTitle");
        System.out.println("roomTitle in CreaStanzaServlet :"+title);
        // manage errors -------
        String error=null;
        if (title==null)  error="titolo della stanza non specificato";
        else if (roomMap.get("title")!=null) error="stanza \""+title+"\" già esistente";
        if (error!=null) {
            request.setAttribute("errorMsg", error);
            RequestDispatcher rd=request.getRequestDispatcher("errorCreatingRoom.jsp");
            rd.forward(request, response);
            return; //questo dovrebbe essere inutile
        }
        // end error mgmt
        Room aRoom=new Room(title,ctx);
        request.setAttribute("stanza", aRoom);
        RequestDispatcher rd=request.getRequestDispatcher("showStanza.jsp");
        rd.forward(request, response);
    }   
}
